
#define F_CPU 16000000L
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>


#define ADCIN PA7   //definicja ADCIN (wejcie ADC)
int main()
{
	
	//Uruchomienie ADC, wewntrzne napiecie odniesienia, tryb pojedynczej konwersji, preskaler 128, wejcie PIN7, wynik do prawej
	ADCSRA =   (1<<ADEN) //ADEN: ADC Enable (uruchomienie przetwornika)
	
	//ADPS2:0: ustawienie preskalera, preskaler= 128
	|(1<<ADPS0)
	|(1<<ADPS1)
	|(1<<ADPS2);
	
	ADMUX  =  (0<<REFS1) | (1<<REFS0) 
	|(1<<MUX2) | (1<<MUX1); //Input Channel Selections (ADC7 - Pin 7 )
	
	//ustawienie wejc/wyj
	DDRB=0xff;
	DDRD=0x00; //Nieuywane Piny na porcie C jako wyjcia
	PORTD=0x00;
	DDRA=0x00; //Ustawienie Wejcia ADC

	
	while(1)//ptla gwna
	{
			ADCSRA |= (1<<ADSC); //ADSC: uruchomienie pojedynczej konwersji
			
			while(ADCSRA & (1<<ADSC)); //czeka na zakoczenie konwersji

			if(ADC<100)//jeli wynik ADC mniejszy od 100 gasi wszystkie diody
			{
				PORTB=0x00;
			}
			else if(ADC<200)//jeli 200>ADC>=100 wieci 1 dioda
			{
				PORTB=0x01;
			}
			else if(ADC<300)//jeli 300>ADC>=200 wiec 2 diody
			{
				PORTB=0x03;
			}
			else if(ADC<400)//jeli 400>ADC>=300 wiec 3 diody
			{
				PORTB=0x07;
			}
			else if(ADC<500)//jeli 500>ADC>=400 wiec 4 diody
			{
				PORTB=0x0f;
			}
			else if(ADC<600)//jeli 600>ADC>=500 wiec 5 diody
			{
				PORTB=0x1f;
			}
			else if(ADC<700)//jeli 700>ADC>=600 wiec 6 diody
			{
				PORTB=0x3f;
			}
			else if(ADC<800)//jeli 800>ADC>=700 wiec 7 diody
			{
				PORTB=0x7f;
			}
			else if(ADC<900)//jeli 900>ADC>=800 wiec 8 diody
			{
				PORTB=0xff;
			}
			else if(ADC<1000)//jeli 1000>ADC>=900 wiec na zmian po 4 diody
			{
				PORTB=0xf0;
				_delay_ms(200);
				PORTB=0x0f;
				_delay_ms(200);
			}
			else if(ADC<1100)//jeli 1100>ADC>=1000 diody zaczynaj mruga
			{
				PORTB=0xff;
				_delay_ms(100);
				PORTB=0x00;
				_delay_ms(100);
			}
		
		
		
	}
}
